--[[

This mod allows the player to create new rabbit holes using captured rabbits

--]]

PrefabFiles = 
{
	"rabhole",
}

GROUND = GLOBAL.GROUND

local notags = {'NOBLOCK', 'player', 'FX'}
local function test(inst, pos)
	local tiletype = GLOBAL.GetGroundTypeAtPosition(pos)

	local ground_OK = tiletype ~= GROUND.UNDERROCK and tiletype ~= GROUND.IMPASSABLE and tiletype ~= GROUND.ROAD and tiletype ~= GROUND.ROCKY and tiletype ~= GROUND.CARPET and tiletype ~= GROUND.CHECKER and tiletype ~= GROUND.WOODFLOOR

	local player = GLOBAL.GetPlayer()
	local slot = GLOBAL.EQUIPSLOTS.HANDS
	if player.components.inventory and player.components.inventory.equipslots[slot] then
		local pfname = player.components.inventory.equipslots[slot].prefab
		if pfname ~= "shovel" and pfname ~= "goldenshovel" and pfname ~= "redshovel" and pfname ~= "blueshovel" then
			return false
		end
	else
		return false
	end

	if ground_OK then
		local MouseCharacter = GLOBAL.TheInput:GetWorldEntityUnderMouse()
		if MouseCharacter and not MouseCharacter:HasTag("player") then
			return false
		end

		local ents = GLOBAL.TheSim:FindEntities(pos.x,pos.y,pos.z, 4, nil, notags)
		local min_spacing = inst.components.deployable.min_spacing or 2

		for k, v in pairs(ents) do
			if v ~= inst and v.entity:IsValid() and v.entity:IsVisible() and not v.components.placer and v.parent == nil then
				if GLOBAL.distsq( GLOBAL.Vector3(v.Transform:GetWorldPosition()), pos) < min_spacing*min_spacing then
					return false
				end
			end
		end
		return true
	end
	return false
end

local function ondeploy(inst, pt)
	local hole = GLOBAL.SpawnPrefab("rabbithole")

	if hole then
		local player = GLOBAL.GetPlayer()
		local shovel = player.components.inventory.equipslots[GLOBAL.EQUIPSLOTS.HANDS]
		hole:Hide()
		hole.Transform:SetPosition(pt.x, pt.y, pt.z)
		if shovel then
			player.sg:GoToState("dig_start")
		end

		hole:DoTaskInTime(30*GLOBAL.FRAMES, function()
			hole:Show()
			if shovel and shovel.components.finiteuses then
				shovel.components.finiteuses:Use(1)
			end
		end)

		inst:Remove()
	else
		inst.sg:GoToState("stunned")
		inst.Transform:SetPosition(pt.x, pt.y, pt.z)
	end
end

local function CollectUseActions2(doer, target, actions)
end

function doTweak(inst)
	inst:AddComponent("stackable")
	if inst.components.stackable.maxsize < 4 then
		inst.components.stackable.maxsize = 4
	end
	inst.components.stackable.CollectUseActions = CollectUseActions2
	inst:AddComponent("deployable")
	inst.components.deployable.test = test
	inst.components.deployable.ondeploy = ondeploy
	inst.components.deployable.min_spacing = 2
end

AddPrefabPostInit("rabbit", doTweak)

